package proyectot1;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.Scanner;

public class Juegos {

    static Scanner sc = new Scanner(System.in);

    public static void lsep() {
        //Un poco inecesario pero es por comodidad.
        System.out.println("*****************************************************"); // separador.
    }

    public char menu() {

        boolean validar;
        char opc;

        do {
            validar = true;

            System.out.print("Menú principal:"
                    + "\n\t 1 - Primitiva  (1€)"
                    + "\n\t 2 - Quiniela   (0.5€ por apuesta)"
                    + "\n\t 3 - Loreteria  (12€)"
                    + "\n\t 0 - Salir"
                    + "\nEleccion de juego:");

            /*Los try, catch los pongo para que si hay un error,
             es decir, cuando simplemente dan enter sin nada y falla el charAt por que no existe la posicion 0,
             que no se salga del programa y ni tampoco del bucle hasta que la opcion sea correcta.
             */
            try {
                opc = sc.nextLine().charAt(0);
            } catch (Exception e) {
                opc = ' ';
            }

            switch (opc) {
                case '1':
                case '2':
                case '3':
                case '0':

                    break;

                default:
                    System.err.println("La Opcion " + opc + " es incorrecta porfavor introduce una opcion válida.");
                    validar = false;
            }
            lsep();

        } while (!validar);

        return opc;
    }

    public boolean pregunta(String pregunta) {
        boolean preg = true;
        boolean validar = true;

        while (validar) {

            System.out.print(pregunta);

            char opc;

            try {
                opc = sc.nextLine().toLowerCase().charAt(0);
            } catch (Exception e) {
                opc = ' ';
            }

            switch (opc) {
                case 's':
                    preg = true;
                    validar = false;
                    break;
                case 'n':
                    preg = false;
                    validar = false;
                    break;
                default:
                    System.err.println("Error, porfavor introduce una opcion válida");
            }//sw
        }//while

        return preg;
    }

    //El metodo Fecha te muestra cuanto es el siguiente sorteo, apuesta y te dice cuantos dias quedan.
    public static void fecha(int DiaSemana, String Apuesta) {

        GregorianCalendar hoy = new GregorianCalendar();

//      hoy.get(Calendar.YEAR), hoy.get(Calendar.MONTH), 24 , 8, 0  Meter en ProxS para una fecha customizado, para hacer pruebas.
        GregorianCalendar proxS = new GregorianCalendar();

        int dias = 0;

        while (proxS.get(Calendar.DAY_OF_WEEK) != DiaSemana || (proxS.get(Calendar.DAY_OF_WEEK) == DiaSemana && (proxS.get(Calendar.HOUR_OF_DAY) >= 21))) {

            proxS.add(Calendar.DAY_OF_WEEK, 1);
            proxS.set(proxS.get(Calendar.YEAR), proxS.get(Calendar.MONTH), proxS.get(Calendar.DAY_OF_MONTH), 6, 0);
            dias++;

        }

        SimpleDateFormat sdf = new SimpleDateFormat("EEEE' 'dd' de 'MMMM' de 'YYYY");

        if (dias == 0) {
            System.out.println("Siguiente " + Apuesta + ": " + sdf.format(proxS.getTime()) + "\nQuedan " + dias + " días,¡puedes jugar hasta las 9, corre!");
        } else {
            System.out.println("Siguiente " + Apuesta + ": " + sdf.format(proxS.getTime()) + "\nQuedan " + dias + " días hasta " + Apuesta);
        }

    }

    public static String gran(int i) {
        String cRan = "";
        for (int j = 0; j < i; j++) {
            cRan += ((int) (Math.random() * 9));
        }
        return cRan;
    }

    //Juegos:
    public double primitiva() {

        fecha(5, "sorteo");

        String apuesta = "";

        for (int i = 0; i < 6; i++) {
            String ran = String.valueOf((int) (Math.random() * (49) + 1));

            while (apuesta.contains(ran)) {     //Hace que nunca se repita el mismo número
                ran = String.valueOf((int) (Math.random() * (49) + 1));
            }

            apuesta = apuesta + " " + ran; // genera la apuesta

        }

        String compl = gran(1);

        String reg = gran(1);

        while (compl.equals(reg)) {       //Para que el complementario y el reintregro no sean iguales.
            reg = gran(1);
        }

        System.out.println("Apuesta: " + apuesta);

        System.out.println("Complementerios:" + compl + "      Registro:" + reg);

        lsep();

        return 1;
    }

    public double quiniela() {

        fecha(1, "jornada");

        boolean validar = true;
        int apuestas = 0;
        while (validar) {

            System.out.print("¿Cuántas apuestas quieres (2-8)?:");

            try {
                apuestas = Integer.parseInt(sc.nextLine());
            } catch (Exception e) {
            }

            if (apuestas < 2 || apuestas > 8) {
                System.err.println("Error, número de apuestas incorrecto, solo números del 2 al 8.");
            } else {
                validar = false;
            }
        }

        for (int i = 1; i <= apuestas; i++) {

            System.out.print("Apuesta " + i + ":");
            for (int j = 0; j < 15; j++) {
                String Ap = "12X";
                System.out.print(" " + Ap.charAt((int) (Math.random() * 3)));

            }
            System.out.println();
        }
        lsep();
        return apuestas * 0.5;
    }

    public double loteria() {

        fecha(7, "sorteo");

        boolean calidar = true;

        String dec = "";

        do {
            System.out.print("Introduce una terminación maxima de 3 cifras (ENTER si te da igual):");
            dec = sc.nextLine();
            boolean ContLetra = false;

            //Detecta si algún decimal introducido es una letra.
            for (int i = 0; i < dec.length(); i++) {

                int ASCII = (int) (dec.toLowerCase().charAt(i));

                if (ASCII >= 97 && ASCII <= 122) {
                    ContLetra = true;
                }
            }//for

            if (dec.length() > 3 || ContLetra) {
                System.err.println("Error, sólo puedes meter tres números");
            } else {
                calidar = false;
            }

        } while (calidar);

        String subDec = ""; // los digitos a generar.

        dec = gran(5 - dec.length()) + dec;

        String serie = gran(3);

        String fraccion = gran(2);

        System.out.println("Numero con el que juegas:" + dec
                + "\nSerie:" + serie + "\tFraccion:" + fraccion);

        lsep();

        return 12;
    }

}  //class
